
// Persistence of Vision Ray Tracer Scene Description File
// File: GIFTrees.INC
// Vers: 1.00

// Desc: --------* GIF Trees *--------
//         Contains boxes with GIF mapped trees on them. Will not really stand up
//         to very close scrutiny, so use only in mid to back ground applications.
//         GIF's taken from Axem textures on the web. (www.axem.simplenet.com ???)

// Date: 8th December 1997
// Auth: Chris Hernandez


#declare CBH_GIFTree1 = object {
   box { <-0.5, 0, 0.001> <0.5, 1, 0> }
   texture {
      material_map {
         gif "tree6o.gif" // the file to read (iff/gif/tga/png/sys)
         map_type 0 // 0=planar, 1=spherical, 2=cylindrical, 5=torus
         interpolate 2 // 0=none, 1=linear, 2=bilinear, 4=normalized distance
         once
         texture { pigment { rgbt 1 } }  // texture for color index # 0
         texture {                       // texture for color index # 1
            pigment {
               image_map {
                  gif "tree6.gif"
                  map_type 0
                  interpolate 2
               }
            }
            finish { ambient 0.35 diffuse 0.65 }
         }
      }
      translate -x*0.5
   }
   scale <7, 7, 1>
}

#declare CBH_GIFTree2 = object {
   box { <-0.5, 0, 0.001> <0.5, 1, 0> }
   texture {
      material_map {
         gif "tree10o.gif" // the file to read (iff/gif/tga/png/sys)
         map_type 0 // 0=planar, 1=spherical, 2=cylindrical, 5=torus
         interpolate 2 // 0=none, 1=linear, 2=bilinear, 4=normalized distance
         once
         texture { pigment { rgbt 1 } }  // texture for color index # 0
         texture {                       // texture for color index # 1
            pigment {
               image_map {
                  gif "tree10.gif"
                  map_type 0
                  interpolate 2
               }
            }
            finish { ambient 0.35 diffuse 0.65 }
         }
      }
      translate -x*0.5
   }
   scale <4.69, 7.00, 1>
}

#declare CBH_GIFTree3 = object {
   box { <-0.5, 0, 0.001> <0.5, 1, 0> }
   texture {
      material_map {
         gif "tree2o.gif" // the file to read (iff/gif/tga/png/sys)
         map_type 0 // 0=planar, 1=spherical, 2=cylindrical, 5=torus
         interpolate 2 // 0=none, 1=linear, 2=bilinear, 4=normalized distance
         once
         texture { pigment { rgbt 1 } }  // texture for color index # 0
         texture {                       // texture for color index # 1
            pigment {
               image_map {
                  gif "tree2.gif"
                  map_type 0
                  interpolate 2
               }
            }
            finish { ambient 0.35 diffuse 0.65 }
         }
      }
      translate -x*0.5
   }
   scale <1.36, 8.46, 1>
}

#declare CBH_GIFTree4 = object {
   box { <-0.5, 0, 0.001> <0.5, 1, 0> }
   texture {
      material_map {
         gif "tree3o.gif" // the file to read (iff/gif/tga/png/sys)
         map_type 0 // 0=planar, 1=spherical, 2=cylindrical, 5=torus
         interpolate 2 // 0=none, 1=linear, 2=bilinear, 4=normalized distance
         once
         texture { pigment { rgbt 1 } }  // texture for color index # 0
         texture {                       // texture for color index # 1
            pigment {
               image_map {
                  gif "tree3.gif"
                  map_type 0
                  interpolate 2
               }
            }
            finish { ambient 0.35 diffuse 0.65 }
         }
      }
      translate -x*0.5
   }
   scale <5.76, 7.00, 1>
}


#declare CBH_GIFTree5 = object {
   box { <-0.5, 0, 0.001> <0.5, 1, 0> }
   texture {
      material_map {
         gif "tree7o.gif" // the file to read (iff/gif/tga/png/sys)
         map_type 0 // 0=planar, 1=spherical, 2=cylindrical, 5=torus
         interpolate 2 // 0=none, 1=linear, 2=bilinear, 4=normalized distance
         once
         texture { pigment { rgbt 1 } }  // texture for color index # 0
         texture {                       // texture for color index # 1
            pigment {
               image_map {
                  gif "tree7.gif"
                  map_type 0
                  interpolate 2
               }
            }
            finish { ambient 0.35 diffuse 0.65 }
         }
      }
      translate -x*0.5
   }
   scale <3.99, 7.00, 1>
}



#declare CBH_GIFTree6 = object {
   box { <-0.5, 0, 0.001> <0.5, 1, 0> }
   texture {
      material_map {
         gif "tree8o.gif" // the file to read (iff/gif/tga/png/sys)
         map_type 0 // 0=planar, 1=spherical, 2=cylindrical, 5=torus
         interpolate 2 // 0=none, 1=linear, 2=bilinear, 4=normalized distance
         once
         texture { pigment { rgbt 1 } }  // texture for color index # 0
         texture {                       // texture for color index # 1
            pigment {
               image_map {
                  gif "tree8.gif"
                  map_type 0
                  interpolate 2
               }
            }
            finish { ambient 0.35 diffuse 0.65 }
         }
      }
      translate -x*0.5
   }
   scale <4.37, 7.00, 1>
}

